Package groovy.transform

# Enum AutoCloneStyle

java.lang.Object
java.lang.Enum<AutoCloneStyle>
groovy.transform.AutoCloneStyle

All Implemented Interfaces:
  `Serializable`, `Comparable<AutoCloneStyle>`, `Constable`

public enum AutoCloneStyle extends Enum<AutoCloneStyle>
Intended style to use for cloning when using the `@`AutoClone annotation.

Since:
  1.8.0
Author:
  Paul King
See Also:
  - `AutoClone`

## Nested Class Summary

## Nested classes/interfaces inherited from class java.lang.Enum

`Enum.EnumDesc<E extends Enum<E>>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`CLONE`
Uses only cloning.
`COPY_CONSTRUCTOR`
Uses the copy constructor pattern.
`SERIALIZATION`
Uses serialization to clone.
`SIMPLE`
Uses the no-arg constructor followed by property/field copying/cloning.

## Method Summary

Modifier and Type
Method
Description
`static AutoCloneStyle`
`valueOf(String name)`
Returns the enum constant of this type with the specified name.
`static AutoCloneStyle[]`
`values()`
Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### CLONE

public static final AutoCloneStyle CLONE
Uses only cloning.

### SIMPLE

public static final AutoCloneStyle SIMPLE
Uses the no-arg constructor followed by property/field copying/cloning.

### COPY_CONSTRUCTOR

public static final AutoCloneStyle COPY_CONSTRUCTOR
Uses the copy constructor pattern.

### SERIALIZATION

public static final AutoCloneStyle SERIALIZATION
Uses serialization to clone.

## Method Details

### values

public static AutoCloneStyle[] values()
Returns an array containing the constants of this enum type, in the order they are declared.

Returns:
  an array containing the constants of this enum type, in the order they are declared

### valueOf

public static AutoCloneStyle valueOf(String name)
Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null